/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    app_threadx.c
  * @author  MCD Application Team
  * @brief   ThreadX applicative file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2020-2021 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "app_threadx.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "main.h"
#include "app_touchgfx.h"
#include "Debug.h"
#include "buzzer.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
#define  APP_CFG_TASK_GUI_PRIO                          6u
#define  APP_CFG_TASK_GUI_STK_SIZE                    	(8192 * 10u)

static  ULONG64    AppTaskGuiStk[APP_CFG_TASK_GUI_STK_SIZE/8];
static TX_THREAD 	GuiThread;

#define  APP_CFG_TASK_IDLE_PRIO                          7u
#define  APP_CFG_TASK_IDLE_STK_SIZE                    	(2048)

static  ULONG64    AppTaskIdleStk[APP_CFG_TASK_IDLE_STK_SIZE/8];
static TX_THREAD 	IdleThread;

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
uint8_t g_beepSwtich = 0;
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */
#if 1
MusicPara_T TAB_CUSTOM_MUSIC[]=
{
	{ DO_HI,		2u,		60}
	,{ EOT,		0u,	0u	}
};
#endif
void StartIdleTask(unsigned long thread_input)
{
	uint8_t flag = 0,cnt  = 0;
	HAL_TIM_PWM_Start(&htim15, TIM_CHANNEL_2);
	g_beepSwtich = 0;
	HAL_GPIO_WritePin(GPIOE, GPIO_PIN_5, GPIO_PIN_RESET);
    Buzzer_Init();

  for(;;)
  {
	if(g_beepSwtich)
	{
        //DEBUG_MSG("Beep Runing\r\n");

		BuzzMusicSet(TAB_CUSTOM_MUSIC);//TAB_KEYERROR_MUSIC
		BuzzOn();
		g_beepSwtich = 0;
		HAL_GPIO_WritePin(GPIOE, GPIO_PIN_5, GPIO_PIN_SET);

	}
    Buzzer_Process();
    tx_thread_sleep(10);
    cnt++;
    if(cnt > 50)
    {
    	cnt = 0;
    	flag++;
		flag %= 2;
		if(flag)
		{
			//if(g_sysInfo.led)
			{
				HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_1);
				HAL_TIMEx_PWMN_Start(&htim1, TIM_CHANNEL_2);
				HAL_TIMEx_PWMN_Start(&htim1, TIM_CHANNEL_3);
			}

		}
		else
		{
			HAL_TIM_PWM_Stop(&htim1, TIM_CHANNEL_1);
			HAL_TIMEx_PWMN_Stop(&htim1, TIM_CHANNEL_2);
			HAL_TIMEx_PWMN_Stop(&htim1, TIM_CHANNEL_3);

		}
    }
  }
}
/* USER CODE END PFP */

/**
  * @brief  Application ThreadX Initialization.
  * @param memory_ptr: memory pointer
  * @retval int
  */
UINT App_ThreadX_Init(VOID *memory_ptr)
{
  UINT ret = TX_SUCCESS;
  /* USER CODE BEGIN App_ThreadX_MEM_POOL */

  /* USER CODE END App_ThreadX_MEM_POOL */

  /* USER CODE BEGIN App_ThreadX_Init */
  tx_thread_create(&GuiThread, (CHAR*)"TouchGFX", TouchGFX_Task, 0,
            AppTaskGuiStk, APP_CFG_TASK_GUI_STK_SIZE,
                                  5, 5,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);

  tx_thread_create(&IdleThread, (CHAR*)"Idle", StartIdleTask, 0,
		  AppTaskIdleStk, APP_CFG_TASK_IDLE_STK_SIZE,
		  APP_CFG_TASK_IDLE_PRIO, APP_CFG_TASK_IDLE_PRIO,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);
  /* USER CODE END App_ThreadX_Init */

  return ret;
}

  /**
  * @brief  Function that implements the kernel's initialization.
  * @param  None
  * @retval None
  */
void MX_ThreadX_Init(void)
{
  /* USER CODE BEGIN  Before_Kernel_Start */

  /* USER CODE END  Before_Kernel_Start */

  tx_kernel_enter();

  /* USER CODE BEGIN  Kernel_Start_Error */

  /* USER CODE END  Kernel_Start_Error */
}

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */
